<style>


</style>
<template>
    <div class="analytics_brief_ct">
        <h2 class="brief_title">
            <span class="brief_analytics_icon icon"></span>
            <span>{{ lang.view_analytics }}</span>
        </h2>
        <div class="analytics_brief">
            <!-- brief_items_ct_start -->
            <div class="brief_items_ct">
                <div class="brief_item">
                    <div class="brief_item_title">
                        <span>{{ lang.head_block_num }}</span>
                    </div>
                    <div class="brief_item_content">
                         <router-link :to="{name: 'block_view'}">
                             {{ split_long_num(head_block_num) || '...' }}
                            </router-link>
                    </div>
                </div>

                <div class="brief_item">
                    <div class="brief_item_title">
                        <span>{{ lang.transaction_num }}</span>
                    </div>
                    <div class="brief_item_content">
                        <router-link :to="{name: 'transaction_view'}">
                             {{ split_long_num(tranaction_num) || '...' }}
                        </router-link>
                    </div>
                </div>

                <div class="brief_item">
                    <div class="brief_item_title">
                        <span>{{ lang.user_num }}</span>
                    </div>
                    <div class="brief_item_content">
                        <router-link :to="{name: 'accounts_view'}">
                         {{ split_long_num(user_num) || '...' }}
                        </router-link>
                    </div>
                </div>

                <div class="brief_item ">
                    <div class="brief_item_title">
                        <span>{{ lang.contract_num }}</span>
                    </div>
                    <div class="brief_item_content">
                        <router-link :to="{name: 'contract_account_list'}">
                         {{ split_long_num(CONTRACT_ACCOUNT_NUM) || '...' }}
                        </router-link>
                    </div>
                </div>

                <!-- <div class="brief_item">
                    <div class="brief_item_title">
                        <span>{{ lang.token_num }}</span>
                    </div>
                    <div class="brief_item_content">
                         <router-link :to="{name: 'account_token_list'}">
                             {{ split_long_num(TOKEN_NUM) || '...' }}
                            </router-link>
                    </div>
                </div>

                <div class="brief_item">
                    <div class="brief_item_title">
                        <span>{{ lang.vote_user_num }}</span>
                    </div>
                    <div class="brief_item_content">
                        <router-link :to="{name: 'web_wallet_view'}">
                             {{ split_long_num(total_voted_user_num) || '...' }}
                        </router-link>
                    </div>
                </div>

                <div class="brief_item">
                    <div class="brief_item_title">
                        <span>{{ lang.vote_coin }}</span>
                    </div>
                    <div class="brief_item_content">
                        <router-link :to="{name: 'web_wallet_view'}">
                         {{ split_long_num(total_voted) || '...' }}
                        </router-link>
                    </div>
                </div> -->


            </div>
            <!-- brief_items_ct_end -->

            <!-- brief_items_ct_start -->
            <div class="brief_items_ct" style="display: none;">
                
                <!-- <div class="brief_item brief_item_50">
                    <div class="brief_item_title">
                        <span>{{ lang.contract_num }}</span>
                    </div>
                    <div class="brief_item_content">
                        <router-link :to="{name: 'contract_account_list'}">
                         {{ split_long_num(CONTRACT_ACCOUNT_NUM) || '...' }}
                        </router-link>
                    </div>
                </div> -->

                <!-- <div class="brief_item brief_item_50">
                    <div class="brief_item_title">
                        <span>{{ lang.eosc_num }}</span>
                        <question v-bind:params="info_texts.desc_eosc_num"></question>
                    </div>
                    <div class="brief_item_content">
                        <router-link :to="{name: 'accounts_view'}">
                         {{ split_long_num(total_eosc_num) || '...' }}
                        </router-link>
                    </div>
                </div> -->

                <!-- <div class="brief_item brief_item_100">
                    <div class="brief_item_title">
                        <span>{{ lang.vote_percent }}</span>
                        <question v-bind:params="info_texts.vote_percent"></question>
                    </div>
                    <div class="brief_item_content">
                         <div class="view_brief_detail process_bar_ct">
                            <div class="process_bar_txt">{{ percent }}%</div>
                            <div class="process_bar" ref="process_bar">
                                <div class="process_bar_inner" v-bind:style="process_bar_inner_style">
                                    {{ process_bar_inner_width }}
                                    <div class="process_bar_tag">
                                        <span>{{ percent }}%</span>
                                        <div class="process_bar_tag_arrow"></div>
                                    </div>
                                </div>
                            </div>
                            <div class="process_bar_txt process_bar_txt_max">100%</div>
                        </div>
                    </div>
                </div> -->

            </div>
            <!-- brief_items_ct_end -->
        </div>
    </div>
</template>
<script>
import store from '../../data/store.js';
import { lang } from '../../data/lang.js'
import question from './question_info.vue'
import {
    split_long_num,
    wait_time
} from '../utils/utils'
export default {
    data () {
        return {
            stared_auto_update: true,
            lang: lang.data,
            process_bar_inner_style: {
                width: 0,
                display: 'none'
            },
            info_texts: {
                desc_eosc_num: {
                    info_text: lang.data.desc_eosc_num
                },
                vote_percent: {
                    info_text: lang.data.desc_vote_percent
                }
            }
        }
    },
    components: {
        question
    },
    computed: {
        head_block_num () {
            return store.state.monitor_brief.info.head_block_num;
        },
        tranaction_num () {
            return store.state.monitor_brief.TRANSACTION_NUM.total;
        },
        user_num () {
            return store.state.monitor_brief.ACCOUNT_NUM.total;
        },
        CONTRACT_ACCOUNT_NUM () {
            return store.state.monitor_brief.CONTRACT_ACCOUNT_NUM.total;  
        },
        TOKEN_NUM () {
            return store.state.monitor_brief.TOKEN_NUM.total;  
        },
        total_voted () {
            return store.state.monitor_brief.total_voted.total;  
        },
        total_voted_user_num () {
            return store.state.monitor_brief.total_voted_user_num.total;  
        },
        today_transfer () {
            return store.state.monitor_brief.today_transfer.total; 
        },
        origin_assets () {
            return parseInt(store.state.monitor_brief.total_actived_coin.total) || 0;
        },
        total_eosc_num () {
            if(!this.head_block_num) return this.origin_assets;
            const ten_expand = 0,
                  three_expand = 5822891,
                  five_expand = 12767154;

            return (three_expand - ten_expand) * 10 
                    + (five_expand - three_expand) * 3 
                    + (this.head_block_num - five_expand) * 5
                    + this.origin_assets;
        },
        percent () {
            if(!this.total_voted || !this.head_block_num) return 0;
            return (this.total_voted * 100 / this.total_eosc_num).toFixed(1);
        }
    },
    watch: {
        percent (current, pre) {
            // this.check_process_bar(current);
        }
    },
    mounted () {
        this.init();
        this.update_data();
        // this.check_process_bar(this.percent);
    },
    destroyed () {
        this.reset();
    },
    methods: {
        init () {
            this.stared_auto_update = true;
        },
        reset () {
            this.stared_auto_update = false;
        },
        async update_data () {
            await Promise.all([ store.dispatch('update_info'), store.dispatch('update_info_user_transaction') ]);
            if(!this.stared_auto_update) return ;
            await wait_time(5);
            this.update_data();
        },
        async check_process_bar (current) {
            // await wait_time(1);
            let width = this.$refs.process_bar.offsetWidth;
            let precess_bar_width = width * current / 100;
            if(precess_bar_width > 0){
                this.process_bar_inner_style.width = width * current / 100 + 'px';
                this.process_bar_inner_style.display = 'block';
            }
        },
        split_long_num
    }
}
</script>